#if OSD_TYPE == BVHUD

#define sport Serial1

void osd_init()
{sport.begin(9600);
}

/*buffer format:
0-sync word changed (0xcb, 0x34)
1  packet type (0 - ahi,bat,cur,mah, 1 - nav, 2 - maintenance
       0               1               2                        3           4
2      rollH           G force         temperature(baro)      point num     point num
3      rollL           gpslat1 5 digs  gpsSPD kph             gpslat1       altH
4      pitchH x10      gpslat2         gpsALTH m              gpslat2       altL
5      pitchL x10      gpslat3         gpsALTL                gpslat3       --
6      yawH            gpslat4         bvHUD keyboard         gpslat4       --
7      yawL            gpslon1         ---                    gpslon1       --
8      control         gpslon2         status                 gpslon2       --
9      gps_hdH         gpslon3         config (1 - OSD off)   gpslon3       --
10     gps_hdL         gpslon4         emerg                  gpslon4       --


==
status:
0..3
        0-Manual
*/

/*
  bvHUD keyboard:
0x80 - setup ON
 OR:
0 - keys released
1 - up    (elevator)
2 - down  (elevator)
3 - escape (ailerons)
4 - enter (ailerons)


*/




void osd_heartbeat() // send each packet via
{byte j=0;
static byte osd_pak_seq[16]={0,3,0,2,0,4,0,1,0,3,0,2,0,4,0,1};
static byte bvhud_tmp=0;
int dcmr,dcmp,hom,alt_tmp;
static byte osd_pak=0;
static byte osd_sync=0xcb;
static byte osd_seq_cnt=0;
static byte osd_target_cnt=0;
osd_seq_cnt++;osd_seq_cnt&=15;
osd_pak=osd_pak_seq[osd_seq_cnt]; // types from 0 to 4 interleaved
switch(osd_pak)

{ case 0:  // type 0 
           // roll pitch yaw, mode, gps_heading
dcmr=roll_sensor*0.01; // degrees x1
dcmp=pitch_sensor*0.1; // degrees x10
hom=yaw_sensor*0.1; // yaw x10

sport.write(osd_sync);
sport.write(osd_pak);
spp_writes(dcmr);
spp_writes(dcmp);
spp_writes(hom);
sport.write((byte)control_mode);  // voltage is unused - FREEEEEE 2 bytes
spp_writes((int)(g_gps->ground_course*0.1)); 
break;

  case 1:  // type 1
  // GPS coords (2x4b Long with 5 digs after dot
sport.write(osd_sync);
sport.write(osd_pak);
sport.write(osd_pak);
spp_writel((long)current_loc.lat*0.00001);  
spp_writel((long)current_loc.lng*0.00001);  
  
break;
  case 2: // type 2
          // gps speed, altitude, sat count, emergency
  alt_tmp=(current_loc.alt - home.alt)/100;
sport.write(osd_sync);
sport.write(osd_pak);
sport.write(gyro.z*1.0204); // G force
sport.write((byte)(g_gps->ground_speed*0.036)); //m/s *100 transform to KPH 
spp_writes(alt_tmp);  
// write keyboard
  if (!bvHUD_setup) sport.write((uint8_t)0);
  else {
        dcmr=APM_RC.InputCh(CH_ROLL);
        dcmp=APM_RC.InputCh(CH_PITCH);
               if (dcmp>1600) sport.write((uint8_t)0x81);
          else if (dcmp<1400) sport.write((uint8_t)0x82);
          else if (dcmr>1600) sport.write((uint8_t)0x83);
          else if (dcmr<1400) sport.write((uint8_t)0x84);
          else sport.write((uint8_t)0x80);
       }
  sport.write((uint8_t)0);


sport.write((byte)g_gps->num_sats) ;//
sport.write((uint8_t)1);
j=0; // count emergency signals
if(APM_RC.GetState()!=1) j|=2; // radio failure
sport.write(j); //write state
break;

  case 3: // type 3
          // home and other waypoints coords (GPS) - do not tx if home was not set
//  int alt_tmp=(current_loc.alt - home.alt)/100;
osd_target_cnt++;osd_target_cnt&=1; // 2 points for now
  if (home_set_flag) // tx if home is set only
  {

switch(osd_target_cnt)
  {case 0: // HOME waypoint
  sport.write(osd_sync);
  sport.write((char)(APM_BMP085.Temp*0.1));
  sport.write(osd_target_cnt);
  spp_writel((long)home.lat*0.00001);  
  spp_writel((long)home.lng*0.00001);  
  break;
  case 1: // NEXT waypoint
  sport.write(osd_sync);
  sport.write(osd_pak);
  sport.write(osd_target_cnt);
  spp_writel((long)next_WP.lat*0.00001);  
  spp_writel((long)next_WP.lng*0.00001);  
  break;    
  }
  } // end home_set_flag condition
break;

  case 4: // type 4
          // home and other WPs altitude
  if (home_set_flag) // tx if home is set only
  {
switch(osd_target_cnt)
  {case 0: // HOME waypoint
  sport.write(osd_sync);
  sport.write(osd_pak);
  sport.write(osd_target_cnt);
  spp_writes(0);  // home alt is always zero
  spp_writes(0);  // dummy bytes
  spp_writel(0);  
  break;
  case 1: // NEXT waypoint
  sport.write(osd_sync);
  sport.write(osd_pak);
  sport.write(osd_target_cnt);
 alt_tmp=(next_WP.alt - home.alt)/100;
  spp_writes(alt_tmp);  
  spp_writes(0);  // dummy bytes
  spp_writel(0);  
  break;    
  }
  }// end home_set_flag condition
  break;
}
// end txing packet
osd_sync^=255;
}

void spp_writel(long in)
{
sport.write((char)(in>>24));  
sport.write((char)(in>>16));  
sport.write((char)(in>>8));  
sport.write((char)(in&255));  
}
void spp_writes(int in)
{
sport.write((char)(in>>8));  
sport.write((char)(in&255));  
}

#endif // osd selector

//###############################################################


#if OSD_TYPE==DISABLED // dummy OSD
void osd_init(void)
{return;}
void osd_heartbeat(void)
{return;}

#endif
